<?php


function formulaires_telecharger_cog_charger()
{
    include_spip('cog_config');
    $tab_objet = cog_config_tab_fichier();
    foreach ($tab_objet as $key => &$objet) {
        if (is_array($objet['fichier'])) {
            $objet['fichier'] = implode(',', $objet['fichier']);
        }
        if (0 === stripos($objet['fichier'], "http")) {
            $objet = $objet;
        } else {
            unset($tab_objet[$key]);
        }
    }
    return array('tab_objet' => $tab_objet);
}


function formulaires_telecharger_cog_verifier_dist()
{
    include_spip('cog_config');
    include_spip('inc/config');

    $erreurs = [];
    $tab_objet = cog_config_tab_fichier();
    $objet = _request('objet');
    if (count($objet) < 1) {
        $erreurs['message_erreur'] = _T('cog:erreur_choix');
        $erreurs['objet'] = _T('cog:erreur_choix');

    } else {
        if (!isset($tab_objet[$objet[0]])) {
            $erreurs['objet'] = _T('cog:fichier_incorrect');
            $erreurs['message_erreur'] = $erreurs['message_erreur'] . _T('cog:fichier_incorrect');
        }
    }

    return $erreurs;
}


// https://code.spip.net/@inc_editer_mot_dist
function formulaires_telecharger_cog_traiter_dist()
{
    include_spip('cog_config');
    include_spip('inc/cog_import');
    $tab_objet = cog_config_tab_fichier();

    $tab_fichier_telecharger = [];
    $objet_nom = "";
    $objet = _request('objet');

    foreach ($objet as $iValue) {
        $objet_nom = $objet_nom . $iValue . ' ';
        $tab_fichier = cog_tab_fichier_telecharger($tab_objet[$iValue]['fichier']);
        foreach ($tab_fichier as $fichier) {
            $nom_fichier = cog_telecharger_fichier_distant($fichier);
            if ($nom_fichier) {
                $tab_fichier_telecharger[] = $nom_fichier;
            }
        }
    }
    $retour['editable'] = true;
    if (count($tab_fichier_telecharger) == count($objet)) {
        if (count($objet) == 1) {
            $retour['message_ok'] = 'Le fchier ' . $objet_nom . ' a bien été télécharger, vous pouvez procéder à son importation.';
        } else {
            $retour['message_ok'] = 'Les fichiers ' . $objet_nom . ' ont bien été télécharger, vous pouvez procéder à leur importation.';
        }
    } else {
        $retour['message_erreur'] = 'Problème dans l\'importation du fichier';
    }
    return $retour;

}


function cog_telecharger_fichier_distant($source)
{
    include_spip('inc/distant');
    include_spip('inc/config');


    $fichier = copie_locale($source, 'force');
    if (file_exists(_DIR_RACINE . $fichier)) {
        $infos_fichier = pathinfo($fichier);
        $emplacement = sous_repertoire(_DIR_TMP, lire_config('cog/chemin_donnee'));
        @chmod($emplacement, 0777);
        $nom_fichier = $emplacement . $infos_fichier['filename'] . '.' . $infos_fichier['extension'];

        if ($infos_fichier['extension'] === 'zip') {
            include_spip('inc/joindre_document');
            include_spip('inc/archives');
            $zip = new Spip\Archives\SpipArchives(_DIR_RACINE . $fichier);

            if (!$infos = $zip->informer()) {
                spip_log(
                    'charger_decompresser erreur zip ' . $zip->erreur() . ' ' . $zip->message() . ' pour paquet: ' . $infos['archive'],
                    'teleport' . _LOG_ERREUR
                );

                return $zip->message();
            }
            $target = _DIR_TMP;
            if (!$zip->deballer($target)) {
                spip_log(
                    'charger_decompresser erreur tar ' . $zip->erreur() . ' ' . $zip->message() . ' pour paquet: ' . $infos['archive'],
                    'teleport' . _LOG_ERREUR
                );
                return $zip->message();
            }


            if (isset($infos['fichiers'][0])) {
                foreach ($infos['fichiers'] as $fichier) {
                    if ($fichier['filename'] !== "readme.txt"){
                        rename( _DIR_TMP.$fichier['filename'], $emplacement . $fichier['filename']);
                    }
                }
            }

            unlink(_DIR_RACINE .$nom_fichier);
            return $nom_fichier;
        }
        else{
            rename(_DIR_RACINE . $nom_fichier, $emplacement);
            return $nom_fichier;
        }

    }
    return false;


}

